NEWDESeq2ComplexDesign <- function(x,conditions,libTypes,the.file,pvaladj,Project){

  require(DESeq2)

  pvaladj = as.numeric(pvaladj)
 
  countData <- x

  print("You loaded this count file: ")
  print(head(countData))

  colData = data.frame(row.names=colnames(countData), condition=conditions, libType=libTypes)
  # colData = data.frame(row.names=colnames(countData),condition=c("treated","treated","control","control"),libType=c("single-end","paired-end","paired-end","paired-end"))

  dds <- DESeqDataSetFromMatrix(countData = countData, colData = colData, design = ~ condition)

  #colData(dds)$condition <- factor(colData(dds)$condition, levels=c(control,treated))
  colData <- colData[,c("condition","libType")]

  ## ----multifactor---------------------------------------------------------
  colData(dds)

  ## ----copyMultifactor-----------------------------------------------------
  ddsMF <- dds

  ## ----replaceDesign,cache=TRUE--------------------------------------------
  design(ddsMF) <- formula(~ libType + condition)

######################################## ANALISYS ###################################

  ## ----multiResults--------------------------------------------------------
  dds <-  DESeq2::DESeq(ddsMF)
  res <- results(dds)
  print("First five lines of the results.")
  print( head(res) )

  ## ----multiTypeResults----------------------------------------------------
  #resMFType <- results(ddsMF, contrast=c("type","single-read","paired-end"))
  #print("Firts five lines of the results.")
  #print( head(resMFType) )


 if(Sys.info()[[1]]=="Windows"){
  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")
  the.file2 = strsplit(the.file,"\\\\") 
  the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile
  outputName=paste(the.file2,"_results_DESeq2ComplexDesign.txt", sep="")

     message=paste("Results of DESeq2 have been saved in the ", Project,"\\Results folder!", sep="")
     print(message)

  b=paste(a,outputName,sep="\\")

  write.table( as.data.frame(res), file = b, quote=FALSE, sep="\t", row.names=TRUE)  

  list_DE_DESEQ2 = subset(as.data.frame(res), padj < pvaladj) # select significant genes

  outputName=paste(the.file2,"_padj=",pvaladj,"_DE_genes_DESeq2ComplexDesign.txt", sep="")

  b=paste(a,outputName,sep="\\")

  write.table(list_DE_DESEQ2, file = b , quote=FALSE, sep="\t", row.names=TRUE) 
 
  #PLOTS 

  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")
  outputName=paste(the.file2,"_Dispersion_Local_DESeq2ComplexDesign.pdf", sep="")
  b=paste(a,outputName,sep="\\")
  ddsLocal <- estimateDispersions(dds, fitType="local")
  DESeq2::plotDispEsts(ddsLocal)
  dev.print(device = pdf, file=b)
  dev.off()
  outputName=paste(the.file2,"_Dispersion_Mean_DESeq2ComplexDesign.pdf", sep="")
  b=paste(a,outputName,sep="\\")
  ddsMean <- estimateDispersions(dds, fitType="mean")
  DESeq2::plotDispEsts(ddsMean)
  dev.print(device = pdf, file=b)
  dev.off()
  outputName=paste(the.file2,"_Dispersion_DESeq2ComplexDesign.pdf", sep="")
  b=paste(a,outputName,sep="\\")
  DESeq2::plotDispEsts(dds)
  dev.print(device = pdf, file=b)

#write into the project report
  report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.Rmd",sep="")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message2 <- paste(" * In the *DESeq2 Interface*, you clicked the **Run DESeq2ComplexDesign** button at `", Sys.time(),"` and the ",outputName," file has been saved in the `", Project,"\\Results` folder.", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

 message2 <- paste("You chose the following count file: `",the.file2,"`, padj: `",pvaladj,"`, Project: `",Project,"`, ",sep="\n")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message1 <- paste("Factors= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("), ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("LibTypes= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",libTypes[1:(length(libTypes)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",libTypes[length(libTypes)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("). ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste(" This R code has been run:",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" ```{r} ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   x = read.table('",the.file,"',header=TRUE,row.names=1)", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   the.file ='",the.file,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   Project ='", Project,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message1 <- paste("conditions= c(")
     write(message1, file = report,ncolumns = if(is.character(message1)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("libTypes= c(")
     write(message1, file = report,ncolumns = if(is.character(message1)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",libTypes[1:(length(libTypes)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",libTypes[length(libTypes)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("pvaladj='",pvaladj,"'",sep="")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("pvaladj = as.numeric(pvaladj)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")
 
     message5 <- paste("countData <- x",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("print('You loaded this count file: ')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("print(head(countData))",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("colData = data.frame(row.names=colnames(countData), condition=conditions, libType=libTypes)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("dds <- DESeqDataSetFromMatrix(countData = countData, colData = colData, design = ~ condition)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("colData <- colData[,c('condition','libType')]",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("## ----multifactor---------------------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("colData(dds)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("## ----copyMultifactor-----------------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("ddsMF <- dds",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("## ----replaceDesign,cache=TRUE--------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("design(ddsMF) <- formula(~ libType + condition)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("######################################## ANALISYS ###################################",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("## ----multiResults--------------------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("dds <-  DESeq2::DESeq(ddsMF)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("res <- results(dds)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("print('First five lines of the results.')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste(" print( head(res) )",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  a=paste(getwd(),'\\RNASeqGUI_Projects\\',Project,'\\Results\\',sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  the.file2 = strsplit(the.file,'\\')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_results_DESeq2ComplexDesign.txt', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("    message=paste('Results of DESeq2 have been saved in the ', Project,'\\Results folder!', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("    print(message)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  #write.table( as.data.frame(res), file = b, quote=FALSE, sep='\t', row.names=TRUE)  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  list_DE_DESEQ2 = subset(as.data.frame(res), padj < pvaladj) # select significant genes",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_padj=',pvaladj,'_DE_genes_DESeq2ComplexDesign.txt', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  #write.table(list_DE_DESEQ2, file = b , quote=FALSE, sep='\t', row.names=TRUE) ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")
 
  message5 <- paste("  #PLOTS ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  a=paste(getwd(),'\\RNASeqGUI_Projects\\',Project,'\\Plots\\',sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_Dispersion_Local_DESeq2.pdf', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  ddsLocal <- estimateDispersions(dds, fitType='local')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  DESeq2::plotDispEsts(ddsLocal)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_Dispersion_Mean_DESeq2ComplexDesign.pdf', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  ddsMean <- estimateDispersions(dds, fitType='mean')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  DESeq2::plotDispEsts(ddsMean)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_Dispersion_DESeq2ComplexDesign.pdf', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  DESeq2::plotDispEsts(dds)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message8 <- paste(" ``` ",sep="\n")
write(message8, file = report,ncolumns = if(is.character(message8)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" _______________________________________________________________________ ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")


 }else{  #Linux

  a=paste(getwd(),"/RNASeqGUI_Projects/",Project,"/Results/",sep="")

  the.file2 = strsplit(the.file,"/")

  the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile

  outputName=paste(the.file2,"_results_DESeq2ComplexDesign.txt", sep="")

     message=paste("Results of DESeq2 have been saved in the ", Project,"/Results folder!", sep="")
     print(message)

  b=paste(a,outputName,sep="/")

  write.table( as.data.frame(res), file = b, quote=FALSE, sep="\t", row.names=TRUE)  

  list_DE_DESEQ2 = subset(as.data.frame(res), padj < pvaladj) # select significant genes

  outputName=paste(the.file2,"_padj=",pvaladj,"_DE_genes_DESeq2ComplexDesign.txt", sep="")

  b=paste(a,outputName,sep="/")

  write.table(list_DE_DESEQ2, file = b , quote=FALSE, sep="\t", row.names=TRUE) 
 
  #PLOTS 

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="")
  outputName=paste(the.file2,"_Dispersion_Local_DESeq2ComplexDesign.pdf", sep="")
  b=paste(a,outputName,sep="/")
  ddsLocal <- estimateDispersions(dds, fitType="local")
  DESeq2::plotDispEsts(ddsLocal)
  dev.print(device = pdf, file=b)
  dev.off()
  outputName=paste(the.file2,"_Dispersion_Mean_DESeq2ComplexDesign.pdf", sep="")
  b=paste(a,outputName,sep="/")
  ddsMean <- estimateDispersions(dds, fitType="mean")
  DESeq2::plotDispEsts(ddsMean)
  dev.print(device = pdf, file=b)
  dev.off()
  outputName=paste(the.file2,"_Dispersion_DESeq2ComplexDesign.pdf", sep="")
  b=paste(a,outputName,sep="/")
  DESeq2::plotDispEsts(dds)
  dev.print(device = pdf, file=b)

#write into the project report
  report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.Rmd",sep="")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message2 <- paste(" * In the *DESeq2 Interface*, you clicked the **Run DESeq2ComplexDesign** button at `", Sys.time(),"` and the ",outputName," file has been saved in the `", Project,"/Results` folder.", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

 message2 <- paste("You chose the following count file: `",the.file2,"`, padj: `",pvaladj,"`, Project: `",Project,"`, ",sep="\n")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message1 <- paste("Factors= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("), ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("LibTypes= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",libTypes[1:(length(libTypes)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",libTypes[length(libTypes)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("). ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste(" This R code has been run:",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" ```{r} ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   x = read.table('",the.file,"',header=TRUE,row.names=1)", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   the.file ='",the.file,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   Project ='", Project,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message1 <- paste("conditions= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("libTypes= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",libTypes[1:(length(libTypes)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",libTypes[length(libTypes)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("pvaladj='",pvaladj,"'",sep="")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("pvaladj = as.numeric(pvaladj)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")
 
     message5 <- paste("countData <- x",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("print('You loaded this count file: ')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("print(head(countData))",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("colData = data.frame(row.names=colnames(countData), condition=conditions, libType=libTypes)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("dds <- DESeqDataSetFromMatrix(countData = countData, colData = colData, design = ~ condition)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("colData <- colData[,c('condition','libType')]",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("## ----multifactor---------------------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("colData(dds)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("## ----copyMultifactor-----------------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("ddsMF <- dds",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("## ----replaceDesign,cache=TRUE--------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("design(ddsMF) <- formula(~ libType + condition)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("######################################## ANALISYS ###################################",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("## ----multiResults--------------------------------------------------------",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("dds <-  DESeq2::DESeq(ddsMF)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("res <- results(dds)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("print('Firts five lines of the results.')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste(" print( head(res) )",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  a=paste(getwd(),'/RNASeqGUI_Projects/',Project,'/Results/',sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  the.file2 = strsplit(the.file,'/')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_results_DESeq2ComplexDesign.txt', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("    message=paste('Results of DESeq2 have been saved in the ', Project,'/Results folder!', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("    print(message)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  #write.table( as.data.frame(res), file = b, quote=FALSE, sep='\t', row.names=TRUE)  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  list_DE_DESEQ2 = subset(as.data.frame(res), padj < pvaladj) # select significant genes",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_padj=',pvaladj,'_DE_genes_DESeq2ComplexDesign.txt', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  #write.table(list_DE_DESEQ2, file = b , quote=FALSE, sep='\t', row.names=TRUE) ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")
 
  message5 <- paste("  #PLOTS ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  a=paste(getwd(),'/RNASeqGUI_Projects/',Project,'/Plots/',sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_Dispersion_Local_DESeq2ComplexDesign.pdf', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  ddsLocal <- estimateDispersions(dds, fitType='local')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  DESeq2::plotDispEsts(ddsLocal)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_Dispersion_Mean_DESeq2ComplexDesign.pdf', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  ddsMean <- estimateDispersions(dds, fitType='mean')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  DESeq2::plotDispEsts(ddsMean)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  outputName=paste(the.file2,'_Dispersion_DESeq2ComplexDesign.pdf', sep='')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

  message5 <- paste("  DESeq2::plotDispEsts(dds)",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message8 <- paste(" ``` ",sep="\n")
write(message8, file = report,ncolumns = if(is.character(message8)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" _______________________________________________________________________ ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")


 }

  print(" FINISHED ! ")

  res

}
