NoiDE2 <- function(x,conditions,TissueRuns,replicate_type,p,the.file,Project){

require(NOISeq)

  p = as.numeric(p)

  myfactors = data.frame(Tissue = conditions, TissueRun = TissueRuns)
  mydata <- NOISeq::readData(data=x, factors=myfactors)

  print("You loaded this count file: ")
  print(head(as.matrix(x)))

  mynoiseq = noiseq(mydata, k = 0.5, norm = "rpkm", factor="Tissue", pnr = 0.2, nss = 5, v = 0.02, lc = 1, replicates = replicate_type)

  print('First five lines of the results.')
  print( head(mynoiseq@results[[1]]) )

  list_DE_NOISEQ = subset(mynoiseq@results[[1]], prob > p) # select significant genes

 if(Sys.info()[[1]]=="Windows"){
  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")
  the.file2 = strsplit(the.file,"\\\\") 
  the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile

  outputName=paste(the.file2,"_results_NOISeq.txt", sep="")

  b=paste(a,outputName,sep="\\")

  write.table(mynoiseq@results[[1]], file = b , quote=FALSE, sep="\t", row.names=TRUE)

  outputName=paste(the.file2,"_prob=",p,"_DE_genes_NOISeq.txt", sep="")

  b=paste(a,outputName,sep="\\")

  write.table(list_DE_NOISEQ, file = b , quote=FALSE, sep="\t", row.names=TRUE)

  a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")

  outputName=paste(the.file2,"_NOISeq.pdf", sep="")

  b=paste(a,outputName,sep="\\")

  DE.plot(mynoiseq, q = p, graphic = "expr", log.scale = TRUE)

  dev.print(device = pdf, file=b)

     message=paste("Results of NoiSeq have been saved in the ", Project,"\\Results folder!", sep="")
     print(message)

#write into the project report
  report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.Rmd",sep="")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message2 <- paste(" * In the *NOISeq Interface*, you clicked the **Run NOISeq** button at `", Sys.time(),"` and the ",outputName," file has been saved in the `", Project,"\\Plots` folder.", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

 message2 <- paste("You chose the following count file: `",the.file2,"`, prob: `",p,"`, Project: `",Project,"`, ",sep="\n")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message1 <- paste("Tissue= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("), ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("TissueRun= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",TissueRuns[1:(length(TissueRuns)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",TissueRuns[length(TissueRuns)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("). ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste(" This R code has been run:",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" ```{r} ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   x = read.table('",the.file,"',header=TRUE,row.names=1)", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   the.file ='",the.file,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   Project ='", Project,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("   replicate_type ='", replicate_type,"'", sep="")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message4 <- paste("p='",p,"'",sep="")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("conditions= c(")
     write(message1, file = report,ncolumns = if(is.character(message1)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("TissueRuns= c(")
     write(message1, file = report,ncolumns = if(is.character(message1)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",TissueRuns[1:(length(TissueRuns)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",TissueRuns[length(TissueRuns)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  p = as.numeric(p)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  myfactors = data.frame(Tissue = conditions, TissueRun = TissueRuns)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  mydata <- NOISeq::readData(data=x, factors=myfactors)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print('You loaded this count file: ')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print(head(as.matrix(x)))",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  mynoiseq = noiseq(mydata, k = 0.5, norm = 'rpkm', factor='Tissue', pnr = 0.2, nss = 5, v = 0.02, lc = 1, replicates = replicate_type)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print('First five lines of the results.')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print( head(mynoiseq@results[[1]]) )",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  list_DE_NOISEQ = subset(mynoiseq@results[[1]], prob > p) # select significant genes",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  a=paste(getwd(),'\\RNASeqGUI_Projects\\',Project,'\\Results\\',sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  the.file2 = strsplit(the.file,'\\')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste(" the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  outputName=paste(the.file2,'_results_NOISeq.txt', sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  #write.table(mynoiseq@results[[1]], file = b , quote=FALSE, sep='\t', row.names=TRUE)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  outputName=paste(the.file2,'_prob=',p,'_DE_genes_NOISeq.txt', sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  #write.table(list_DE_NOISEQ, file = b , quote=FALSE, sep='\t', row.names=TRUE)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  a=paste(getwd(),'\\RNASeqGUI_Projects\\',Project,'\\Plots\\',sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  outputName=paste(the.file2,'_NOISeq.pdf', sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  b=paste(a,outputName,sep='\\')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  DE.plot(mynoiseq, q = p, graphic = 'expr', log.scale = TRUE)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message8 <- paste(" ``` ",sep="\n")
write(message8, file = report,ncolumns = if(is.character(message8)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" _______________________________________________________________________ ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")




  }else{ #Linux

  a=paste(getwd(),"/RNASeqGUI_Projects/",Project,"/Results/",sep="")

  the.file2 = strsplit(the.file,"/")

  the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile

  outputName=paste(the.file2,"_results_NOISeq.txt", sep="")

  b=paste(a,outputName,sep="/")

  write.table(mynoiseq@results[[1]], file = b , quote=FALSE, sep="\t", row.names=TRUE)

  outputName=paste(the.file2,"_prob=",p,"_DE_genes_NOISeq.txt", sep="")

  b=paste(a,outputName,sep="/")

  write.table(list_DE_NOISEQ, file = b , quote=FALSE, sep="\t", row.names=TRUE)

  a=paste(getwd(),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="")

  outputName=paste(the.file2,"_NOISeq.pdf", sep="")

  b=paste(a,outputName,sep="/")

  DE.plot(mynoiseq, q = p, graphic = "expr", log.scale = TRUE)

  dev.print(device = pdf, file=b)

     message=paste("Results of NoiSeq have been saved in the ", Project,"/Results folder!", sep="")
     print(message)

#write into the project report
  report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.Rmd",sep="")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message2 <- paste(" * In the *NOISeq Interface*, you clicked the **Run NOISeq** button at `", Sys.time(),"` and the ",outputName," file has been saved in the `", Project,"\\Plots` folder.", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

 message2 <- paste("You chose the following count file: `",the.file2,"`, prob: `",p,"`, Project: `",Project,"`, ",sep="\n")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message1 <- paste("Tissue= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("), ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("TissueRun= c(")
     write(message1, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",TissueRuns[1:(length(TissueRuns)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",TissueRuns[length(TissueRuns)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste("). ")
     write(message4, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste(" This R code has been run:",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" ```{r} ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   x = read.table('",the.file,"',header=TRUE,row.names=1)", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   the.file ='",the.file,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("   Project ='", Project,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("   replicate_type ='", replicate_type,"'", sep="")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message4 <- paste("p='",p,"'",sep="")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("conditions= c(")
     write(message1, file = report,ncolumns = if(is.character(message1)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",conditions[1:(length(conditions)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",conditions[length(conditions)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message1 <- paste("TissueRuns= c(")
     write(message1, file = report,ncolumns = if(is.character(message1)) 1 else 5,append = TRUE, sep = "")

     message2 <- paste("'",TissueRuns[1:(length(TissueRuns)-1)],"',",sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "")

     message3 <- paste("'",TissueRuns[length(TissueRuns)],"'",sep="")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "")

     message4 <- paste(") ")
     write(message4, file = report,ncolumns = if(is.character(message4)) 1 else 5,append = TRUE, sep = "")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  p = as.numeric(p)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  myfactors = data.frame(Tissue = conditions, TissueRun = TissueRuns)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  mydata <- NOISeq::readData(data=x, factors=myfactors)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print('You loaded this count file: ')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print(head(as.matrix(x)))",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  mynoiseq = noiseq(mydata, k = 0.5, norm = 'rpkm', factor='Tissue', pnr = 0.2, nss = 5, v = 0.02, lc = 1, replicates = replicate_type)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print('First five lines of the results.')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  print( head(mynoiseq@results[[1]]) )",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

     message3 <- paste("  list_DE_NOISEQ = subset(mynoiseq@results[[1]], prob > p) # select significant genes",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  a=paste(getwd(),'/RNASeqGUI_Projects/',Project,'/Results/',sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  the.file2 = strsplit(the.file,'/')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste(" the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  outputName=paste(the.file2,'_results_NOISeq.txt', sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  #write.table(mynoiseq@results[[1]], file = b , quote=FALSE, sep='\t', row.names=TRUE)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  outputName=paste(the.file2,'_prob=',p,'_DE_genes_NOISeq.txt', sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  #write.table(list_DE_NOISEQ, file = b , quote=FALSE, sep='\t', row.names=TRUE)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  a=paste(getwd(),'/RNASeqGUI_Projects/',Project,'/Plots/',sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  outputName=paste(the.file2,'_NOISeq.pdf', sep='')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  b=paste(a,outputName,sep='/')",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message3 <- paste("  DE.plot(mynoiseq, q = p, graphic = 'expr', log.scale = TRUE)",sep="\n")
     write(message3, file = report,ncolumns = if(is.character(message3)) 1 else 5,append = TRUE, sep = "\n")

message8 <- paste(" ``` ",sep="\n")
write(message8, file = report,ncolumns = if(is.character(message8)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" _______________________________________________________________________ ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")


 }

  mynoiseq@results[[1]]

 

}
