VolcanoNoiSeq <-
function(name,p,results_noi,the.file, Project){

require(NOISeq)

 p = as.numeric(p)
 print ("Probability chosen: ")
 print(p)
 print ("Gene Id chosen: ")
 print(name)
 print('This file has been loaded: ')
 print(head(results_noi))

if(Sys.info()[[1]]=="Windows"){

 a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")
 the.file = strsplit(the.file,"\\\\")
 the.file = the.file[[1]][length(the.file[[1]])]  #estract the namefile
 the.file = substring(the.file,1,nchar(the.file)-4)  # eliminates ".txt"
 plot(results_noi$M, results_noi$prob, col = "black", main="NoiSeq Volcano Plot", xlab="M", ylab="prob", pch=16,cex=0.4)
 DE_genes_NoiSeq = subset(results_noi, prob>p)
 text(DE_genes_NoiSeq$M, DE_genes_NoiSeq$prob, label=substring(row.names(DE_genes_NoiSeq),11,15), col="red", cex=0.5)

 if (name!=""){
   OneGene = subset(results_noi, row.names(results_noi)==name)
   text(OneGene$M, OneGene$prob, label=name, col="green", cex=0.6)
 }

 a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")

 outputName=paste(the.file,"_Volcano_NoiSeq.pdf", sep="")

 b=paste(a,outputName,sep="\\")

 dev.print(device = pdf, file=b)

 #write into the project report
 report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.txt",sep="") 
 message=paste("The ",outputName," file has been saved in the ", Project,"\\Plots folder!", sep="")
 print(message)
 message2 <- paste("You ckicked the Volcano Plot button in the NoiSeq Result Inspection Interface at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"\\Plots folder!", sep="")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

 }else{ #Linux

 the.file2 = strsplit(the.file,"/")

 the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile

 the.file2 = substring(the.file2,1,nchar(the.file2)-4)  # eliminates ".txt"

 plot(results_noi$M, results_noi$prob, col = "black", main="NoiSeq Volcano Plot", xlab="M", ylab="prob", pch=16,cex=0.4)

 DE_genes_NoiSeq = subset(results_noi, prob>p)

 text(DE_genes_NoiSeq$M, DE_genes_NoiSeq$prob, label=substring(row.names(DE_genes_NoiSeq),11,15), col="red", cex=0.5)

 if (name!=""){

   OneGene = subset(results_noi, row.names(results_noi)==name)

   text(OneGene$M, OneGene$prob, label=name, col="green", cex=0.6)

 }

 a=paste(getwd(),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="")

 outputName=paste(the.file2,"_Volcano_NoiSeq.pdf", sep="")

 b=paste(a,outputName,sep="/")

 dev.print(device = pdf, file=b)

#write into the project report
  report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.Rmd",sep="")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

     message2 <- paste(" * In the *Result Inspection Interface*, you clicked the **Volcano Plot** button for NOISeq at `", Sys.time(),"` and the ",outputName," file has been saved in the `", Project,"/Plots` folder.", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

     message5 <- paste("  ",sep="\n")
     write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

 message2 <- paste("You chose the following count file: `",the.file,"`, prob: `",p,"`, Project: `",Project,"`, ",sep="\n")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" ```{r} ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("results_noi = read.table(", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("'",the.file,"',header=TRUE,row.names=1)", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("the.file ='",the.file,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("Project ='", Project,"'", sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("name = '",name,"'",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("p= '",p,"'",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("print('This file has been loaded: ')",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("print(head(results_noi))",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" p = as.numeric(p)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" print ('prob chosen: ')",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" print(p)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" print ('Gene Id chosen: ')",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" print(name)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" the.file2 = strsplit(the.file,'/')",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" the.file2 = the.file2[[1]][length(the.file2[[1]])]  #estract the namefile",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" the.file2 = substring(the.file2,1,nchar(the.file2)-4)  # eliminates '.txt'",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" plot(results_noi$M, results_noi$prob, col = 'black', main='NoiSeq Volcano Plot', xlab='M', ylab='prob', pch=16,cex=0.4)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" DE_genes_NoiSeq = subset(results_noi, prob>p)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" text(DE_genes_NoiSeq$M, DE_genes_NoiSeq$prob, label=substring(row.names(DE_genes_NoiSeq),11,15), col='red', cex=0.5)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" if (name!=''){    OneGene = subset(results_noi, row.names(results_noi)==name)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste("     text(OneGene$M, OneGene$prob, label=name, col='green', cex=0.6) }",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" a=paste(getwd(),'/RNASeqGUI_Projects/',Project,'/Plots/',sep='')",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" outputName=paste(the.file2,'_Volcano_NOISeq.pdf', sep='')",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" b=paste(a,outputName,sep='/')",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" # dev.print(device = pdf, file=b)",sep="")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

message8 <- paste(" ``` ",sep="\n")
write(message8, file = report,ncolumns = if(is.character(message8)) 1 else 5,append = TRUE, sep = "\n")

message5 <- paste(" _______________________________________________________________________ ",sep="\n")
write(message5, file = report,ncolumns = if(is.character(message5)) 1 else 5,append = TRUE, sep = "\n")

}
         
}

