gage_function <- function(file.name,geneSet1,geneSet2,Same.Direction,tTest,zTest,KSTest,useFold,rankTest,compare.input,stouffer.input,Project,datasetsel,conversion,specie){

 require(gage)
 require(gageData)
 require(pathview)
 data(kegg.gs)
 data(go.gs)

 res=NULL

 #file.name="/home/francesco/Desktop/Gage_Results/counts_results_DESeq2.txt"
 #file.name="/home/francesco/Desktop/Gage_Results/deseq2.res.txt"
 #file.name="/home/francesco/Desktop/Gage_Results/a_results_DESeq2.txt"
 # file.name="/home/francesco/Desktop/RNASeqGUI_Projects/Valerio_count1/Results/corsa1.txt_results_EdgeR.txt"
 
 print("Expression data selected: ") 
 print(file.name)
 file.name=read.table(file.name, row.names=1, header=TRUE)
 #file.name=as.matrix(file.name) #to speed up computations
 print("dimensions:")
 print(dim(file.name))
 print(head(file.name))

 #file.name=as.matrix(as.character(file.name))
 #cn=colnames(file.name)
 #hn=grep('HN',cn, ignore.case =TRUE)
 #adh=grep('ADH',cn, ignore.case =TRUE)
 #dcis=grep('DCIS',cn, ignore.case =TRUE)
 #useFold = FALSE
 #rankTest = TRUE
 #compare.input = "unpaired"
 #stouffer.input = FALSE
 #Same.Direction = TRUE
 #specie = "hsa"
 #datasetsel = "hsapiens_gene_ensembl"
 #conversion = TRUE


 if(conversion==TRUE){
   print("Selecting a BioMart database and dataset. PLEASE, WAIT!")
   ensembl=useMart("ensembl",dataset=datasetsel) #to connect to a BioMart database
   results <- getBM(attributes = c("ensembl_gene_id","entrezgene"), mart=ensembl)
   print("Conversion map:")
   print(head(results))
   print("Converting row names from 'ensembl_gene_id' to 'entrezgene'. PLEASE, WAIT!")
   file.name <- mol.sum(mol.data = file.name, id.map = results,sum.method = "mean") 
   print("Expression data modified:")
   print(dim(file.name))
   print(head(file.name))
 }

 out.suffix=NULL

 fc=NULL

 # Do an automatic check whether is deseq or edger

 if (colnames(file.name)[1] == "log2FoldChange") {  # you are using DESeq/DESeq2
   fc=file.name[,'log2FoldChange']
   names(fc)=rownames(file.name)
   sum(is.infinite(fc))
   fc[fc>10]=10
   fc[fc< -10]=-10
   out.suffix="deseq"
   print("You are using an DESeq/DESeq2 result file.")
 }

 if(colnames(file.name)[1] == "logFC"){  # you are using EdgeR
   fc=file.name[,'logFC']
   names(fc)=rownames(file.name)
   out.suffix="edger"
   print("You are using an edgeR result file.")
 }

 exp.fc=fc

 print("Performing gage analysis. PLEASE, WAIT!")

 if (geneSet1==TRUE){ # kegg.gs

   if (tTest==TRUE){  # gs.tTest
     res <- gage(exp.fc, gsets = kegg.gs, ref = NULL, samp = NULL, same.dir = Same.Direction, saaTest = gs.tTest, use.fold = useFold, rank.test = rankTest, compare = compare.input, use.stouffer = stouffer.input)
   }
   if (zTest==TRUE){  # gs.zTest
     res <- gage(exp.fc, gsets = kegg.gs, ref = NULL, samp = NULL, same.dir = Same.Direction, saaTest = gs.zTest, 
                 use.fold = useFold, rank.test = rankTest, compare = compare.input, use.stouffer = stouffer.input)
   }   
   if (KSTest==TRUE){               # gs.KSTest
     res <- gage(exp.fc, gsets = kegg.gs, ref = NULL, samp = NULL, same.dir = Same.Direction, saaTest = gs.KSTest, 
                 use.fold = useFold, rank.test = rankTest, compare = compare.input, use.stouffer = stouffer.input)
   }

 }else{               # go.gs

   if (tTest==TRUE){  # gs.tTest
     res <- gage(exp.fc, gsets = go.gs, ref = NULL, samp = NULL, same.dir = Same.Direction, saaTest = gs.tTest, 
                 use.fold = useFold, rank.test = rankTest, compare = compare.input, use.stouffer = stouffer.input)
   }
   if (zTest==TRUE){  # gs.zTest
     res <- gage(exp.fc, gsets = go.gs, ref = NULL, samp = NULL, same.dir = Same.Direction, saaTest = gs.zTest, 
                 use.fold = useFold, rank.test = rankTest, compare = compare.input, use.stouffer = stouffer.input)
   }   
   if (KSTest==TRUE){              # gs.KSTest
     res <- gage(exp.fc, gsets = go.gs, ref = NULL, samp = NULL, same.dir = Same.Direction, saaTest = gs.KSTest, 
                 use.fold = useFold, rank.test = rankTest, compare = compare.input, use.stouffer = stouffer.input)
   }

 }

 sel <- res$greater[, "q.val"] < 0.1 & !is.na(res$greater[, "q.val"])
 path.ids <- rownames(res$greater)[sel]
 sel.l <- res$less[, "q.val"] < 0.1 & !is.na(res$less[,"q.val"])
 path.ids.l <- rownames(res$less)[sel.l]
 path.ids2 <- substr(c(path.ids, path.ids.l), 1, 8) #put greater and less together
 print("First lines of the results:")
 print(path.ids2)

 if(Sys.info()[[1]]=="Windows"){

                       #view first 3 pathways as demo
 prevwd=getwd()
 setwd(paste(getwd(),"RNASeqGUI_Projects", Project,"Plots", sep="\\"))
 pv.out.list <- sapply(path.ids2, function(pid) pathview( gene.data = exp.fc, pathway.id = pid, species = specie, out.suffix=out.suffix))
 setwd(prevwd)

 #write into the project report
 report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.txt",sep="") 
 message2 <- paste("You ckicked the GAGE button at ", Sys.time()," and the result file has been saved in the ", Project,"\\Results folder!", sep="")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 
 message2 <- paste("You chose the following: ", sep="\n")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")
 
 write.table(res, file = paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Results\\GAGE_result.txt",sep="") , quote=FALSE, sep="\t", row.names=TRUE)
 message=paste("Results of GAGE have been saved in RNASeqGUI_Projects\\", Project,"\\Results folder!", sep="")
 print(message)
 
 }else{         # Linux

                       #view first 3 pathways as demo
 prevwd=getwd()
 setwd(paste(getwd(),"RNASeqGUI_Projects", Project,"Plots", sep="/"))
 pv.out.list <- sapply(path.ids2, function(pid) pathview( gene.data = exp.fc, pathway.id = pid, species = specie, out.suffix=out.suffix))
 setwd(prevwd)

 #write into the project report
 report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.txt",sep="") 
 message2 <- paste("You ckicked the GAGE button at ", Sys.time()," and the result file has been saved in the ", Project,"/Results folder!", sep="")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 
 message2 <- paste("You chose the following", sep="\n")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

 write.table(res, file = paste(getwd(),"/RNASeqGUI_Projects/",Project,"/Results/GAGE_result.txt",sep="") , quote=FALSE, sep="\t", row.names=TRUE)
 message=paste("Results of GAGE have been saved in RNASeqGUI_Projects/", Project,"/Results folder!", sep="")
 print(message)

 }

 print("FINISHED!")

 res

}
